package com.tongran.rocketmq.controller;

import com.tongran.common.core.utils.poi.ExcelUtil;
import com.tongran.common.core.web.controller.BaseController;
import com.tongran.common.core.web.domain.AjaxResult;
import com.tongran.common.core.web.page.TableDataInfo;
import com.tongran.common.log.annotation.Log;
import com.tongran.common.log.enums.BusinessType;
import com.tongran.common.security.annotation.RequiresPermissions;
import com.tongran.rocketmq.domain.InitialSwitchInfoTemp;
import com.tongran.rocketmq.service.IInitialSwitchInfoTempService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 交换机监控信息Controller
 * 
 * @author tongran
 * @date 2025-08-26
 */
@RestController
@RequestMapping("/temp")
@RequiresPermissions("rocketmq:switchInfo")
public class InitialSwitchInfoTempController extends BaseController
{
    @Autowired
    private IInitialSwitchInfoTempService initialSwitchInfoTempService;

    /**
     * 查询交换机监控信息列表
     */
    @GetMapping("/list")
    public TableDataInfo list(InitialSwitchInfoTemp initialSwitchInfoTemp)
    {
        startPage();
        List<InitialSwitchInfoTemp> list = initialSwitchInfoTempService.selectInitialSwitchInfoTempList(initialSwitchInfoTemp);
        return getDataTable(list);
    }

    /**
     * 导出交换机监控信息列表
     */
    @Log(title = "交换机监控信息", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, InitialSwitchInfoTemp initialSwitchInfoTemp)
    {
        List<InitialSwitchInfoTemp> list = initialSwitchInfoTempService.selectInitialSwitchInfoTempList(initialSwitchInfoTemp);
        ExcelUtil<InitialSwitchInfoTemp> util = new ExcelUtil<InitialSwitchInfoTemp>(InitialSwitchInfoTemp.class);
        util.exportExcel(response, list, "交换机监控信息数据");
    }

    /**
     * 获取交换机监控信息详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(initialSwitchInfoTempService.selectInitialSwitchInfoTempById(id));
    }

    /**
     * 新增交换机监控信息
     */
    @Log(title = "交换机监控信息", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody InitialSwitchInfoTemp initialSwitchInfoTemp)
    {
        return toAjax(initialSwitchInfoTempService.insertInitialSwitchInfoTemp(initialSwitchInfoTemp));
    }

    /**
     * 修改交换机监控信息
     */
    @Log(title = "交换机监控信息", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody InitialSwitchInfoTemp initialSwitchInfoTemp)
    {
        return toAjax(initialSwitchInfoTempService.updateInitialSwitchInfoTemp(initialSwitchInfoTemp));
    }

    /**
     * 删除交换机监控信息
     */
    @Log(title = "交换机监控信息", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(initialSwitchInfoTempService.deleteInitialSwitchInfoTempByIds(ids));
    }
}
